//+------------------------------------------------------------------+
//|                                                  CandleBreak.mq4 |
//|                                                         SnowBars |
//|                           https://www.mql5.com/ru/users/snowbars |
//+------------------------------------------------------------------+
#property copyright "SnowBars"
#property link      "https://www.mql5.com/ru/users/snowbars"
#property version   "1.00"
#property strict
enum orderstype {Buy_and_Sell,Buy_Orders,Sell_Orders}; //      
input string Txt0 = "----------------->   <----------------";// ----------------------------------------------------------->   
input bool Autotrade = true;
input string Txt1 = "--------------->   <----------------";// ----------------------------------------------------------->   
input int O = 10;// O -   
input int M = 90;// M -    
input int F = 100;// F -    
input int A = 70;// A - 0 %       
input double S = 0.5;// S -    (  0  1) 
input int N = 50;// N -      
input int W = 5;// W -           
input string Txt2 = "---------------->   <-------------------";// ----------------------------------------------------------->
input orderstype OrdersType = Buy_and_Sell;
input int MaxOrders = 10;
input double AutoProcent = 1;// (%)   (0- )
input double LotManual = 0.05;//  
input int Slip = 3;
input int SpreadLimit = 50;// Max  Spread
input int MagicNumber = 1234;
input string Txt3 = "---------------->   <----------------";// ----------------------------------------------------------->
input int StopLoss2 = 0;//  /(0-)
input int BU = 0;// (+/-)(0- )
input int StepT = 50;// TrailingStep (0-TrailingOff)
input string Txt4 = "------------------->  ADX <-------------------";// ----------------------------------------------------------->
input int PeriodADX = 14;// Period ADX 
input ENUM_APPLIED_PRICE PriceADX = PRICE_CLOSE;// Price ADX 
input double uslADX = 25;// ADX    
input string Txt5 = "---------------->  Bollinger <-------------------";// ----------------------------------------------------------->
input int PeriodBollinger = 14;// Period Bollinger
input double Deviation = 2;// DeviationBollinger
input ENUM_APPLIED_PRICE PriceBollinger = PRICE_CLOSE;// Price Bollinger
//---
// 
double OrderIndentNorm,OrderStepNorm,StopLossNorm,TakeProfit,StopLoss,StopLoss2Norm,BUNorm,PipsPendingOrderNorm,AutoProcentNorm,TakeProfitNorm,StepTNorm,Lot;
int n,nn,s,ss,sl,b,bs,bl,no,SlipNorm,fB,fCls,fError;
string MQL_name,name;
//---
double TeloPips,Telo,UpTeloPips,UpTelo,DownTeloPips,DownTelo;
//---
datetime T,TCls;
int fCandleB,fCandleS,Ok50b,Ok50s;
double ClsLot;
int BlockS=0,BlockB=0;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
ChartSetInteger(0,CHART_MODE,CHART_CANDLES);
ChartSetInteger(0,CHART_SHOW_GRID,false );
ChartSetInteger(0,CHART_SCALE,4);
ChartSetInteger(0,CHART_COLOR_CHART_LINE,clrYellow);
   MQL_name=MQLInfoString(MQL_PROGRAM_NAME);
   TakeProfitNorm=TakeProfit*_Point;
   StopLossNorm=StopLoss*_Point;
   AutoProcentNorm=NormalizeDouble(AutoProcent,2);
   SlipNorm=Slip;
      StopLoss2Norm=StopLoss2*_Point;
      BUNorm=BU*_Point;
      StepTNorm=StepT*_Point;
   LOT();
   onTick();
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   ObjectsDeleteAll(0,MQL_name);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick(){onTick();}
void onTick(){
Analiz();
//----
   if(Time[1]!=T){T=Time[1];
//---
      AlgOpenClose();
//---
}
AlgReal();
//----
if(OrdersTotal()!=0){Trall();}
if(fCls!=0){Cls();}
}
//+------------------------------------------------------------------+
void LOT(){
    double MaxLOT=0;
    if(AutoProcent!=0){
         MaxLOT=(AccountEquity()/MarketInfo(Symbol(),MODE_MARGINREQUIRED));MaxLOT*=0.99;Lot=(MaxLOT*0.01)*AutoProcent;}
      else{Lot=LotManual;}
      if(Lot<MarketInfo(Symbol(),MODE_MINLOT)){Lot=MarketInfo(Symbol(),MODE_MINLOT);}
   Lot=NormalizeDouble(Lot,2);}
   
   
//-------------------------------------------------------------------
//   
//-------------------------------------------------------------------
//Sell ("  ")
//---------------------------------
void SS(string Comm=NULL){
   //
   double SL=High[1],TP=0;
   if(Autotrade==true&&(OrdersType==Buy_and_Sell||OrdersType==Sell_Orders)){
            if(MaxOrders>OrdersTotal()&&SpreadLimit>=SymbolInfoInteger(_Symbol,SYMBOL_SPREAD)){
                              if((MarketInfo(_Symbol,MODE_MARGINREQUIRED)*Lot)<AccountFreeMargin()){
                  if(TakeProfit!=0){TP=SymbolInfoDouble(_Symbol,SYMBOL_BID)-TakeProfitNorm;}else{TP=0;}
                  //if(StopLoss!=0){SL=SymbolInfoDouble(_Symbol,SYMBOL_ASK)+StopLossNorm;}else{SL=0;}             
            LOT();int S1=OrderSend(Symbol(),OP_SELL,Lot,Bid,SlipNorm,0,TP,Comm,MagicNumber,0,clrRed);
                  if(S1<0&&fError<3){SS();fError++;Sleep(1000);}}}}}
//---------------------------------
//Buy ("  ")
//---------------------------------
void BB(string Comm=NULL){ 
   //
   double SL=Low[1],TP=0;
   if(Autotrade==true&&(OrdersType==Buy_and_Sell||OrdersType==Buy_Orders)){
         if(MaxOrders>OrdersTotal()&&SpreadLimit>=SymbolInfoInteger(_Symbol,SYMBOL_SPREAD)){
                  if((MarketInfo(_Symbol,MODE_MARGINREQUIRED)*Lot)<AccountFreeMargin()){
                  if(TakeProfit!=0){TP=SymbolInfoDouble(_Symbol,SYMBOL_ASK)+TakeProfitNorm;}else{TP=0;}
                  //if(StopLoss!=0){SL=SymbolInfoDouble(_Symbol,SYMBOL_BID)-StopLossNorm;}else{SL=0;}
            LOT();int B1=OrderSend(Symbol(),OP_BUY,Lot,Ask,SlipNorm,0,TP,Comm,MagicNumber,0,clrBlue);
                  if(B1<0&&fError<3){BB();fError++;Sleep(1000);}}}}}
//-------------------------------------------------------------------
void ClsO(){for (int u = 0; u < OrdersTotal(); u++) {if(OrderSelect(u, SELECT_BY_POS, MODE_TRADES)==TRUE){if(OrderMagicNumber() == MagicNumber){if(OrderSymbol()==_Symbol){
   if((OrderType()==2||OrderType()==3||OrderType()==4||OrderType()==5)&&(IsTradeContextBusy()==0)){if (OrderDelete(OrderTicket())==true){}}}}}}}
//------------------------------------------------------------------
void ClsSS(){for (int u = 0; u < OrdersTotal(); u++) {if(OrderSelect(u, SELECT_BY_POS, MODE_TRADES)==TRUE){if(OrderMagicNumber() == MagicNumber){if(OrderSymbol()==_Symbol){
   if(OrderType()==OP_SELLSTOP&&IsTradeContextBusy()==0){if (OrderDelete(OrderTicket())==true){}}}}}}}
//------------------------------------------------------------------
void ClsBS(){for (int u = 0; u < OrdersTotal(); u++) {if(OrderSelect(u, SELECT_BY_POS, MODE_TRADES)==TRUE){if(OrderMagicNumber() == MagicNumber){if(OrderSymbol()==_Symbol){
   if(OrderType()==OP_BUYSTOP&&IsTradeContextBusy()==0){if (OrderDelete(OrderTicket())==true){}}}}}}}  
//------------------------------------------------------------------
void ClsSL(){for (int u = 0; u < OrdersTotal(); u++) {if(OrderSelect(u, SELECT_BY_POS, MODE_TRADES)==TRUE){if(OrderMagicNumber() == MagicNumber){if(OrderSymbol()==_Symbol){
   if(OrderType()==OP_SELLLIMIT&&IsTradeContextBusy()==0){if (OrderDelete(OrderTicket())==true){}}}}}}}
//------------------------------------------------------------------
void ClsBL(){for (int u = 0; u < OrdersTotal(); u++) {if(OrderSelect(u, SELECT_BY_POS, MODE_TRADES)==TRUE){if(OrderMagicNumber() == MagicNumber){if(OrderSymbol()==_Symbol){
   if(OrderType()==OP_BUYLIMIT&&IsTradeContextBusy()==0){if (OrderDelete(OrderTicket())==true){}}}}}}} 
//------------------------------------------------------------------
void ClsB(){for (int u = 0; u <= OrdersTotal()-1; u++) {if(OrderSelect(u, SELECT_BY_POS, MODE_TRADES)==TRUE){if(OrderMagicNumber() == MagicNumber){if(OrderSymbol()==_Symbol){
   if (OrderType() == OP_BUY&&(IsTradeContextBusy()==0)){if(OrderClose(OrderTicket(),OrderLots(),SymbolInfoDouble(_Symbol,SYMBOL_BID),SlipNorm,Green)==true){}}}}}}}
//------------------------------------------------------------------
void ClsS(){for (int u = 0; u <= OrdersTotal()-1; u++) {if(OrderSelect(u, SELECT_BY_POS, MODE_TRADES)==TRUE){if(OrderMagicNumber() == MagicNumber){if(OrderSymbol()==_Symbol){
   if (OrderType() == OP_SELL&&(IsTradeContextBusy()==0)){if(OrderClose(OrderTicket(),OrderLots(),SymbolInfoDouble(_Symbol,SYMBOL_ASK),SlipNorm,Red)==true){}}}}}}}   
//-------------------------------------------------------------------
void Cls(){TCls=Time[0];Analiz();
   if(fCls==1){if(s!=0){ClsS();}else{fCls=0;}}
   if(fCls==2){if(b!=0){ClsB();}else{fCls=0;}}
   if(fCls==11){Cls50S(ClsLot);}
   if(fCls==22){Cls50B(ClsLot);}
    if(fCls==3){if(ss!=0){ClsSS();}else{fCls=0;}}
    if(fCls==4){if(bs!=0){ClsBS();}else{fCls=0;}}
     if(fCls==5){if(sl!=0){ClsSL();}else{fCls=0;}}
     if(fCls==6){if(bl!=0){ClsBL();}else{fCls=0;}}
      if(fCls==7){if(n!=0){ClsS();ClsB();}else{fCls=0;}}
      if(fCls==8){if(no!=0){ClsO();}else{fCls=0;}}
      if(fCls==9){if(nn!=0){ClsS();ClsB();ClsO();}else{fCls=0;}}}      
      //---
void Trall(){
double Start=0,SL=0,TP=0;
if((StopLoss2!=0||StepT!=0)&&(IsTradeContextBusy()==0)){
   for (int u = OrdersTotal()-1; u >= 0; u--) {
      if(OrderSelect(u, SELECT_BY_POS, MODE_TRADES)==TRUE){
         if(OrderMagicNumber() == MagicNumber){   
            if(OrderType()==0){
               Start=OrderOpenPrice()+StopLoss2Norm;
              if(StepT!=0&&StopLoss2!=0&&(MarketInfo(Symbol(),MODE_BID)>Start)){
              SL=MarketInfo(Symbol(),MODE_BID)-StopLoss2Norm-StepTNorm; 
              if(SL > OrderStopLoss()||OrderStopLoss()==0){SL=MarketInfo(Symbol(),MODE_BID)-StopLoss2Norm;if(OrderModify(OrderTicket(), OrderOpenPrice(), SL, OrderTakeProfit(), 0, clrSkyBlue)==true){;}}}
                if(StopLoss2!=0&&BU!=0){
                SL=OrderOpenPrice()+BUNorm;
                if((MarketInfo(Symbol(),MODE_BID)>Start)&&(OrderStopLoss()<SL||OrderStopLoss()==0)&&(MarketInfo(Symbol(),MODE_BID)>(SL+(SymbolInfoInteger(_Symbol,SYMBOL_TRADE_STOPS_LEVEL)*_Point)))&&(OrderStopLoss()!=SL)){
                if(OrderModify(OrderTicket(), OrderOpenPrice(), SL, OrderTakeProfit(), 0, clrSkyBlue)==true){;}}}
                }
            if(OrderType()==1){
              Start=OrderOpenPrice()-StopLoss2Norm;
              if(StepT!=0&&StopLoss2!=0&&(MarketInfo(Symbol(),MODE_ASK)<Start)){
              SL=MarketInfo(Symbol(),MODE_ASK)+StopLoss2Norm+StepTNorm;  
              if(SL < OrderStopLoss()||OrderStopLoss()==0){SL=MarketInfo(Symbol(),MODE_ASK)+StopLoss2Norm;if(OrderModify(OrderTicket(), OrderOpenPrice(), SL, OrderTakeProfit(), 0, clrOrange)==true){;}}}
                if(StopLoss2!=0&&BU!=0){
                SL=OrderOpenPrice()-BUNorm;
                if((MarketInfo(Symbol(),MODE_ASK)<Start)&&(OrderStopLoss()>SL||OrderStopLoss()==0)&&(MarketInfo(Symbol(),MODE_ASK)<(SL-(SymbolInfoInteger(_Symbol,SYMBOL_TRADE_STOPS_LEVEL)*_Point)))&&(OrderStopLoss()!=SL)){
                if(OrderModify(OrderTicket(), OrderOpenPrice(), SL, OrderTakeProfit(), 0, clrSkyBlue)==true){;}}}}}}}}
                }   
//--- 
void AlgOpenClose(){
double TP=0;
int Ok=0;
int Oki=0;
int OkOk=0;
double adx_0=iADX(NULL,0,PeriodADX,PriceADX,MODE_MAIN,0);
double H_B=iBands(NULL,0,PeriodBollinger,Deviation,0,PriceBollinger,MODE_UPPER,0);
double M_B=iBands(NULL,0,PeriodBollinger,Deviation,0,PriceBollinger,MODE_MAIN,0);
double L_B=iBands(NULL,0,PeriodBollinger,Deviation,0,PriceBollinger,MODE_LOWER,0);
double OneProcO=((M_B-L_B)/_Point)*0.01;
double ProcOB=((Ask-L_B)/_Point)/OneProcO;
double ProcOS=((H_B-Bid)/_Point)/OneProcO;
for(int u=0; u<W;u++){OkOk++;
   if(Low[u]<H_B&&High[u]>H_B){Ok=1;}
   if(Low[u]<M_B&&High[u]>M_B){Ok=1;}
   if(Low[u]<L_B&&High[u]>L_B){Ok=1;}}
//---
if(adx_0<uslADX){Oki=1;}
if(adx_0<uslADX&&Ok==1){
//--
if(BlockB==1&&Bid>M_B){BlockB=0;}
if(BlockS==1&&Bid<M_B){BlockS=0;}
//--
//  
if(b==0&&s==0&&BlockB==0){Ok50b=0;
if(ProcOB<O){fCandleB=1;}
if(Bid>M_B){fCandleB=0;}
if(fCandleB==1){
   if(Open[1]<Close[1]&&Open[2]>Close[2]){
      if(ProcOB<A){
      TP=M_B+(OneProcO*_Point*F);
      BB();TPSLMod(TP,0,0,S);BlockB=1;}}}      
if(fCandleB==1&&ProcOB>O&&Open[1]>Close[1]){fCandleB=0;}}
//--
//  
if(s==0&&b==0&&BlockS==0){Ok50b=0;
if(ProcOS<O){fCandleS=1;}
if(Bid<M_B){fCandleS=0;}
if(fCandleS==1){
   if(Open[1]>Close[1]&&Open[2]<Close[2]){
      if(ProcOS<A){
      TP=M_B-(OneProcO*_Point*F);
      SS();TPSLMod(TP,0,0,S);BlockS=1;}}}
if(fCandleS==1&&ProcOS>O&&Open[1]<Close[1]){fCandleS=0;}}}
//-----
Comment("\n\n( 1 -  / 0 -  )","\n\nCandle filter = ",OkOk," / ",W," ( ",Ok," ) ","\nADX = ",DoubleToString(adx_0,2)," / ",uslADX," ( ",Oki," ) ","\nBuy = ",DoubleToString(ProcOB,2)," / ",O," ( ",fCandleB," )","\nSell = ",DoubleToString(ProcOS,2)," / ",O," ( ",fCandleS," )");      
//-------------------------------------------------------------------------      
      }
//--------------------------------------
void AlgReal(){
double TP=0;
double H_B=iBands(NULL,0,PeriodBollinger,Deviation,0,PriceBollinger,MODE_UPPER,1);
double M_B=iBands(NULL,0,PeriodBollinger,Deviation,0,PriceBollinger,MODE_MAIN,1);
double L_B=iBands(NULL,0,PeriodBollinger,Deviation,0,PriceBollinger,MODE_LOWER,1);
double OneProcO=((M_B-L_B)/_Point)*0.01;
double ProcOB=((Ask-L_B)/_Point)/OneProcO;
double ProcOS=((H_B-Bid)/_Point)/OneProcO;
//Close-------------------------------------------------------
   if(b!=0){
      if(Ok50b==0){TP=M_B+(OneProcO*_Point*F);TPSLMod(TP,0,0,S);}
      else{TP=M_B+(OneProcO*_Point*F);TPSLMod(TP,0,-1);}
   ClsLot=N;
      if(ProcOB>M&&Ok50b==0){
         TP=M_B+(OneProcO*_Point*F);
         fCls=22;TPSLMod(TP,0,-1);Ok50b=1;}
      if(ProcOB>(F+100)){fCls=2;}}
   else{Ok50b=0;}
   if(s!=0){
      if(Ok50s==0){TP=M_B-(OneProcO*_Point*F);TPSLMod(TP,0,0,S);}
      else{TP=M_B-(OneProcO*_Point*F);TPSLMod(TP,0,-1);}
   ClsLot=N;
      if(ProcOS>M&&Ok50s==0){
         TP=M_B-(OneProcO*_Point*F);
         fCls=11;TPSLMod(TP,0,-1);Ok50s=1;}
      if(ProcOS>(F+100)){fCls=1;}}
   else{Ok50s=0;}
}
//--------------------------------------
void Candle(int i=0){
//----
   if(Open[i]>=Close[i]){
      Telo=Open[i]-Close[i];
    UpTelo=High[i]-Open[i];
  DownTelo=Close[i]-Low[i];}
//---  
   if(Open[i]<Close[i]){
      Telo=Close[i]-Open[i];
    UpTelo=High[i]-Close[i];
  DownTelo=Open[i]-Low[i];}
//---
TeloPips=Telo/_Point;  
UpTeloPips=UpTelo/_Point;
DownTeloPips=DownTelo/_Point;
//----   
}
//----------
void Cls50B(double LotClsProc=50,double LotCls=0){double LCls=0;
for (int u = 0; u <= OrdersTotal()-1; u++) {if(OrderSelect(u, SELECT_BY_POS, MODE_TRADES)==TRUE){if(OrderMagicNumber() == MagicNumber){if(OrderSymbol()==_Symbol){
   if (OrderType() == OP_BUY&&(IsTradeContextBusy()==0)){
      if(LotCls!=0){LCls=LotCls;}
      else{
         if(LotClsProc!=0){LCls=OrderLots()*0.01*LotClsProc;}
         else{break;}}
   LCls=NormalizeDouble(LCls,2);
   if(OrderClose(OrderTicket(),LCls,SymbolInfoDouble(_Symbol,SYMBOL_BID),SlipNorm,Green)==true){fCls=0;}}}}}}}
//---
void Cls50S(double LotClsProc=50,double LotCls=0){double LCls=0;
for (int u = 0; u <= OrdersTotal()-1; u++) {if(OrderSelect(u, SELECT_BY_POS, MODE_TRADES)==TRUE){if(OrderMagicNumber() == MagicNumber){if(OrderSymbol()==_Symbol){
   if (OrderType() == OP_SELL&&(IsTradeContextBusy()==0)){
      if(LotCls!=0){LCls=LotCls;}
      else{
         if(LotClsProc!=0){LCls=OrderLots()*0.01*LotClsProc;}
         else{break;}}
   LCls=NormalizeDouble(LCls,2);
   if(OrderClose(OrderTicket(),LCls,SymbolInfoDouble(_Symbol,SYMBOL_ASK),SlipNorm,Green)==true){fCls=0;}}}}}}}
//---------------------
void TPSLMod(double TP=0, double kTP=0 ,double SL=0, double kSL=0){
   if(OrdersTotal()!=0&&(TP!=0||SL!=0)){
   int ModifyOrder;
      for (int u = 0; u <= OrdersTotal()-1; u++) {
         if(OrderSelect(u, SELECT_BY_POS, MODE_TRADES)==TRUE){
            if(OrderMagicNumber() == MagicNumber){
               if(OrderSymbol()==_Symbol){
//---
   if(OrderType()==0){
      if(TP!=0||SL!=0){
         if(TP!=0&&kSL!=0&&TP>OrderOpenPrice()){SL=OrderOpenPrice()-((TP-OrderOpenPrice())*kSL);}
         if(SL!=0&&kTP!=0&&SL<OrderOpenPrice()){TP=OrderOpenPrice()+((OrderOpenPrice()-SL)*kTP);}
         if(TP==-1){TP=OrderOpenPrice()+(SymbolInfoInteger(_Symbol,SYMBOL_SPREAD)*_Point);}
         if(SL==-1){SL=OrderOpenPrice()+(SymbolInfoInteger(_Symbol,SYMBOL_SPREAD)*_Point);}
         SL=NormalizeDouble(SL,_Digits);TP=NormalizeDouble(TP,_Digits);
         if(OrderTakeProfit()!=TP||OrderTakeProfit()!=SL){ModifyOrder = OrderModify(OrderTicket(),OrderOpenPrice(),SL,TP,OrderExpiration(),clrNONE);}}}
//---
   if(OrderType()==1){Print(TP," | ",kTP," | ",SL," | ",kSL);
      if(TP!=0||SL!=0){
         if(TP!=0&&kSL!=0&&TP<OrderOpenPrice()){SL=SL=OrderOpenPrice()+((OrderOpenPrice()-TP)*kSL);}
         if(SL!=0&&kTP!=0&&SL>OrderOpenPrice()){TP=OrderOpenPrice()-((SL-OrderOpenPrice())*kTP);}
         if(TP==-1){TP=OrderOpenPrice()-(SymbolInfoInteger(_Symbol,SYMBOL_SPREAD)*_Point);}
         if(SL==-1){SL=OrderOpenPrice()-(SymbolInfoInteger(_Symbol,SYMBOL_SPREAD)*_Point);}
         SL=NormalizeDouble(SL,_Digits);TP=NormalizeDouble(TP,_Digits);
         if(OrderTakeProfit()!=TP||OrderTakeProfit()!=SL){ModifyOrder = OrderModify(OrderTicket(),OrderOpenPrice(),SL,TP,OrderExpiration(),clrNONE);}}}
}}}}}}
//----------------------------
void Analiz(){
      n=0;nn=0;b=0;s=0;
   if(OrdersTotal()!=0){
      for (int u = 0; u <= OrdersTotal()-1; u++) {
         if(OrderSelect(u, SELECT_BY_POS, MODE_TRADES)==TRUE){
            if(OrderMagicNumber() == MagicNumber){
               if(OrderSymbol()==_Symbol){nn++;
   if(OrderType()==0){b++;n++;}
   if(OrderType()==1){s++;n++;}}}}}}}               